diff --git a/Documentation/filesystems/ceph.txt b/Documentation/filesystems/ceph.txt
index 92ffc9b3b018..e446f5975e8d 100644
--- a/Documentation/filesystems/ceph.txt
+++ b/Documentation/filesystems/ceph.txt
@@ -102,6 +102,86 @@ Mount Options
 	specified, the client's IP address is determined by looking at the
 	address its connection to the monitor originates from.
 
+  fsid=X
+        Specify the cluster's FSID/UUID.
+
+  name=X
+	RADOS user to authenticate as when using CephX. Default: guest
+
+  secret=X
+	Specify the secret key for use with CephX. This option is insecure
+	because it exposes the secret on the command line. To avoid this,
+	use the secretfile option.
+
+  key=X
+	Get secret key from the kernel keys api. More detail please see
+	Documentation/security/keys/core.rst.
+
+  osdkeepalive=X
+	The interval for sending the keepalive (tag + timestamp) to its OSD
+	to ensure any communications channel reset is detected. Default: 5
+	seconds.
+
+  osd_idle_ttl=X
+	The ttl for the osds in the lru list, will close and remove those
+	have not been used for more than a specified time. Default: 60
+	seconds.
+
+  mount_timeout=X
+	Specify the timeout value for mount (in seconds), in the case of
+	a non-responsive Ceph file system. Default: 60 seconds.
+
+  osd_request_timeout=X
+	Specify the timeout value for each osd request (in seconds), in
+	the case of non-responsive and will abort it. Default: 0 seconds,
+	means no timeout.
+
+  share
+	Share the client instance with other superblocks when mounting the
+	same cluster. This is the default.
+
+  noshare
+	Create a new client instance, instead of sharing an existing instance
+	of a client mounting the same cluster.
+
+  crc
+	Use CRC32C calculation for data writes. This is the default.
+
+  nocrc
+	Disable CRC32C calculation for data writes.  If set, the storage node
+	must rely on TCP's error correction to detect data corruption
+	in the data payload.
+
+  cephx_require_signatures
+	Enable require cephx message signing feat. This is the default.
+
+  nocephx_require_signatures
+	Disable require cephx message signing feat.
+
+  cephx_sign_messages
+	Enable message signing. This is the default.
+
+  nocephx_sign_messages
+	Disable message signing.
+
+  tcp_nodelay
+	Disable Nagle's algorithm on client sockets. This is the default.
+
+  notcp_nodelay
+        Enable Nagle's algorithm on client sockets.
+
+  abort_on_full
+	Fail write requests with -ENOSPC when the cluster is full or the data
+	pool reaches its quota. The default behaviour is to block until the
+	full condition is cleared.
+
+  snapdirname=X
+	Specify the name of the hidden snapdir. The default is ".snap".
+
+  mds_namespace=X
+	Specify the name of one filesystem to mount if you have more than
+	one filesystem.
+
   wsize=X
 	Specify the maximum write size in bytes.  Default: 64 MB.
 
@@ -111,52 +191,119 @@ Mount Options
   rasize=X
 	Specify the maximum readahead size in bytes.  Default: 8 MB.
 
-  mount_timeout=X
-	Specify the timeout value for mount (in seconds), in the case
-	of a non-responsive Ceph file system.  The default is 60
-	seconds.
+  caps_wanted_delay_min=X
+	Specify the minimum amount of time for telling the MDS we no
+	longer want caps, in case we reopen the file. Default: 5 seconds.
+
+  caps_wanted_delay_max=X
+	Specify the maximum amount of time for telling the MDS we no
+	longer want caps, in case we reopen the file. Default: 60 seconds.
 
   caps_max=X
 	Specify the maximum number of caps to hold. Unused caps are released
 	when number of caps exceeds the limit. The default is 0 (no limit)
 
+  readdir_max_entries=X
+	Specify the maximum directy entries to read per-request. Default:
+	1024.
+
+  readdir_max_bytes=X
+	Specify the maximum bytes could read per-request when reading directy
+	entries. Default: 512k.
+
+  congestion_kb=X
+	Specify the maximum writeback in flight, scale with available memory.
+	Default: calculated from available memory, but limit the default to
+	256M, at least 1M.
+
+  dirstat
+	Enable funky cat dirname for stats.
+
+  nodirstat
+	Disable funky cat dirname for stats. This is the default.
+
   rbytes
 	When stat() is called on a directory, set st_size to 'rbytes',
 	the summation of file sizes over all files nested beneath that
 	directory.  This is the default.
 
   norbytes
-	When stat() is called on a directory, set st_size to the
-	number of entries in that directory.
-
-  nocrc
-	Disable CRC32C calculation for data writes.  If set, the storage node
-	must rely on TCP's error correction to detect data corruption
-	in the data payload.
+	When stat() is called on a directory, set st_size to the number
+	of entries in that directory.
 
   dcache
-        Use the dcache contents to perform negative lookups and
-        readdir when the client has the entire directory contents in
-        its cache.  (This does not change correctness; the client uses
-        cached metadata only when a lease or capability ensures it is
-        valid.)
+        Use the dcache contents to perform negative lookups and readdir
+	when the client has the entire directory contents in its cache.
+	(This does not change correctness; the client uses cached metadata
+	 only when a lease or capability ensures it is valid.)  This is
+	the default.
 
   nodcache
         Do not use the dcache as above.  This avoids a significant amount of
         complex code, sacrificing performance without affecting correctness,
         and is useful for tracking down bugs.
 
+  asyncreaddir
+	Enable to use the dcache as above for readdir. This is the default.
+
   noasyncreaddir
-	Do not use the dcache as above for readdir.
+	Disable to use the dcache as above for readdir.
 
-  noquotadf
+  ino32
+	Enable and force the ceph fs to report 32 bit ino values. This is
+	useful for 64 bit kernels with 32 bit userspace.
+
+  noino32
+	Disable forcing the ceph fs to report 32 bit ino values. This is
+	the default.
+
+  fsc=X
+	Enable and use fscache cookie as a local presisent cache with a unique
+	qualifier.
+
+  fsc
+	Enable and use fscache cookie as a local presisent cache without any
+	unique qualifier.
+
+  nofsc
+	Disable and do not use fscache cookie as a local presisent cache.
+
+  poolperm
+	Enable the pool rd/wr permission check for read/write. This is the
+	default.
+
+  nopoolperm
+	Disable the pool rd/wr permission check for read/write.
+
+  require_active_mds
+	Enable mount waits if no mds is up.
+
+  norequire_active_mds
+	Disablee mount waits if no mds is up. This is the default.
+
+  quotadf
         Report overall filesystem usage in statfs instead of using the root
-        directory quota.
+        directory quota. This is the default.
 
-  nocopyfrom
-        Don't use the RADOS 'copy-from' operation to perform remote object
+  noquotadf
+	Disable and do not report overall filesystem usage in statfs instead
+	of using the root directory quota.
+
+  copyfrom
+        Enable and use the RADOS 'copy-from' operation to perform remote object
         copies.  Currently, it's only used in copy_file_range, which will revert
-        to the default VFS implementation if this option is used.
+        to the default VFS implementation if this option is used. This is the
+	default.
+
+  nocopyfrom
+        Disable to use the RADOS 'copy-from' operation to perform remote object
+	copies.
+
+  acl
+	Enable the acl. This is the default.
+
+  noacl
+	Disable the acl.
 
   recover_session=<no|clean>
 	Set auto reconnect mode in the case where the client is blacklisted. The